<?php
namespace Setforms2\Shared;

use Setforms2\Shared\Exception\RegistryNotObjectStored;

abstract class Registry
{

    private static $stored_objects = array();

    public static function store($name, $object, $replace = false) {
        // if stored does not need to throw exception.
        if (!isset(self::$stored_objects[$name]) || $replace) {
            self::$stored_objects[$name] = $object;
        }
    }

    public static function get($name) {
        if (!isset(self::$stored_objects[$name])) {
            throw new RegistryNotObjectStored("Haven't a object store in $name!");
        }

        return self::$stored_objects[$name];
    }

    /**
     * @static
     * @return \Doctrine2\ORM\EntityManager
     */
    public static function getEntityManager() {
        return self::get("EntityManager");
    }

    /**
     * @static
     * @return \Doctrine2\DBAL\Connection
     */
    public static function getEntityManagerConnection() {
        return self::get('EntityManagerConnection');
    }

}
