<?php
namespace Teknisa\CRM\Factory;

use Doctrine\ORM\EntityManager;

class crm00004000LeadFactory {
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection       = $entityManager->getConnection();
    }
    
    public function insertParcnegocio($row) {
        try{
            $insert = "INSERT INTO PARCNEGOCIO (NRPARCNEGOCIO, NRORG, NMPRINCIPALPARC, NMSECUNDARIPARC, NRINSCRICAOPARC, IDATIVO, DTINCLUSAO,
                             NRORGINCLUSAO, CDOPERINCLUSAO, CDTIPOPARCPRINCIPAL, CDTIPOINSCRICAO,IDPESSOAFISICA)
             VALUES (:NRPARCNEGOCIO,
                     :NRORG,
                     :NMPRINCIPALPARC,
                     :NMSECUNDARIPARC,
                     :NRINSCRICAOPARC,
                     :IDATIVO,
                      SYSDATE,
                     :NRORGINCLUSAO,
                     :CDOPERINCLUSAO,
                     :CDTIPOPARCPRINCIPAL,
                     :CDTIPOINSCRICAO,
                     :IDPESSOAFISICA)";
            
            $params = array(
                "IDATIVO"               => $row["IDATIVO"],
                "NRPARCNEGOCIO"         => $row["NRPARCNEGOCIO"],
                "NRORG"                 => $row["NRORG"],
                "NMPRINCIPALPARC"       => $row["NMCANDIDATO"],
                "NMSECUNDARIPARC"       => $row["NMFANTCAN"],
                "NRINSCRICAOPARC"       => $row["NRINSJURCAN"],
                "NRORGINCLUSAO"         => $row["NRORG"],
                "CDOPERINCLUSAO"        => $row["CDOPEREVOL"],
                "CDTIPOPARCPRINCIPAL"   => "CANDIDATO",
                "CDTIPOINSCRICAO"       => $row["TIPOINSC"],
                "IDPESSOAFISICA"        => $row["ISCPF"],
            );

            $std = $this->connection->prepare($insert);
            $std->execute($params);
        } catch(\Exception $e) {
            throw $e;
        };
    }
    
    public function getParcnegocio($paramsGetNrparcEstrutura) {

        $find = "SELECT * FROM PARCNEGOCIO
                        WHERE NRPARCNEGOCIO = :NRPARCNEGOCIO
                        AND NRORG = :NRORG";
                 
        try{
            $std = $this->connection->prepare($find);
            $std->execute($paramsGetNrparcEstrutura);
            $return = $std->fetchAll();
            if(!empty($return))
                return $return;
            else 
                return array();
            
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
    public function insertCandidato($row) {
        $insert = "INSERT INTO CRM_CANDIDATO
                (NRCANDIDATO, IDTPIJURCAN, NRINSJURCAN, NMCANDIDATO, NMFANTCAN, DESCTITULOCAN, DSEMAILCAN, DSTELEFONECAN, IDSTATUSCAN, CDSEGMER, NRFUNCCAN,
                CDMODODIVULG, CDPAIS, SGESTADO, CDMUNICIPIO, NMBAIRROCAN, NRPARCPROPRI, NRPARCNEGOCIO, CDFILIAL, NRCONTATO, NRIMOVELENDERECO, CDBAIRRO, NRORG, IDATIVO,
                DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRSEQCONTATO, IDPARCFUNDIDO, DSOBSERVACAOLEAD)
                VALUES (:NRCANDIDATO,
                        :IDTPIJURCAN,
                        :NRINSJURCAN,
                        :NMCANDIDATO,
                        :NMFANTCAN,
                        :DESCTITULOCAN,
                        :DSEMAILCAN,
                        :DSTELEFONECAN,
                        :IDSTATUSCAN,
                        :CDSEGMER,
                        :NRFUNCCAN,
                        :CDMODODIVULG,
                        :CDPAIS,
                        :SGESTADO,
                        :CDMUNICIPIO,
                        :NMBAIRROCAN,
                        :NRPARCPROPRI,
                        :NRPARCNEGOCIO,
                        :CDFILIAL,
                        :NRCONTATO,
                        :NRIMOVELENDERECO,
                        :CDBAIRRO,
                        :NRORG,
                        :IDATIVO,
                        SYSDATE,
                        SYSDATE,
                        :NRORGINCLUSAO,
                        :CDOPERINCLUSAO,
                        :NRSEQCONTATO,
                        :IDPARCFUNDIDO,
                        :DSOBSERVACAOLEAD)";
        $params = array 
        (
            "NRCANDIDATO"               => $row["NRCANDIDATO"],
            "IDTPIJURCAN"               => $row["IDTPIJURCAN"],
            "NRINSJURCAN"               => $row["NRINSJURCAN"],
            "NMCANDIDATO"               => $row["NMCANDIDATO"],
            "NMFANTCAN"                 => $row["NMFANTCAN"],
            "DESCTITULOCAN"             => $row["DESCTITULOCAN"],
            "DSEMAILCAN"                => $row["DSEMAILCAN"],
            "DSTELEFONECAN"             => $row["DSTELEFONECAN"],
            "IDSTATUSCAN"               => $row["IDSTATUSCAN"],
            "CDSEGMER"                  => $row["CDSEGMER"],
            "NRFUNCCAN"                 => $row["NRFUNCCAN"],
            "CDMODODIVULG"              => $row["CDMODODIVULG"],
            "CDPAIS"                    => $row["CDPAIS"],
            "SGESTADO"                  => $row["SGESTADO"],
            "CDMUNICIPIO"               => $row["CDMUNICIPIO"],
            "NMBAIRROCAN"               => $row["NMBAIRROCAN"],
            "NRPARCPROPRI"              => $row["NRPARCPROPRI"],
            "NRPARCNEGOCIO"             => $row["NRPARCNEGOCIO"],
            "CDFILIAL"                  => $row["CDFILIAL"],
            "NRCONTATO"                 => $row["NRCONTATO"],
            "NRIMOVELENDERECO"          => $row["NRIMOVELENDERECO"],
            "CDBAIRRO"                  => $row["CDBAIRRO"],
            "NRORG"                     => $row["NRORG"],
            "IDATIVO"                   => $row["IDATIVO"],
            "NRORGINCLUSAO"             => $row["NRORG"],
            "CDOPERINCLUSAO"            => $row["CDOPEREVOL"],
            "NRSEQCONTATO"              => $row["NRSEQCONTATO"],
            "IDPARCFUNDIDO"             => $row["IDPARCFUNDIDO"],
            "DSOBSERVACAOLEAD"          => $row["DSOBSERVACAOLEAD"]
        );
        try {
            $std = $this->connection->prepare($insert);
            $std->execute($params);
            
            return true;
        } catch(\Exception $e) {
            throw $e;
        };
    }
    
    public function getCandidato($paramsGetNrparcEstrutura) {

        $find = "SELECT * FROM CRM_CANDIDATO
                        WHERE NRCANDIDATO = :NRCANDIDATO
                        AND NRORG = :NRORG";
                 
        try {
            $std = $this->connection->prepare($find);
            $std->execute($paramsGetNrparcEstrutura);
            $return = $std->fetchAll();
            if(!empty($return))
                return $return;
            else 
                return array();
            
        } catch(\Exception $e) {
            throw $e;
        };
    }
    
    public function verifyLeadInsc($paramsVerifyLeadCPNJ) {
        $select =  "SELECT 
                      PARC.NMPRINCIPALPARC,
                      PARC.CDTIPOPARCPRINCIPAL AS TIPOPARC
                    FROM 
                      PARCNEGOCIO PARC
                      JOIN CRM_STATUSPARC STAT
                        ON STAT.NRPARCNEGOCIO = PARC.NRPARCNEGOCIO
                        AND STAT.NRORG = PARC.NRORG
                        AND CRM_NRORGTRAB = :CRM_NRORGTRAB
                    WHERE 
                      PARC.NRINSCRICAOPARC = :INSCRICAO
                      AND (PARC.NRPARCNEGOCIO <> :PKVALUE OR :PKVALUE IS NULL)
                      AND PARC.NRORG = :NRORG";
                      
        try{
            $std = $this->connection->prepare($select);
            $std->execute($paramsVerifyLeadCPNJ);
            $leads = $std->fetchAll();
            return $leads;
        } catch(\Exception $e) {
            throw $e;
        };
    }
    
    public function verifyLeadCNPJ($paramsVerifyLeadCPNJ){
        try{
            $select =  "SELECT 
                          PARC.NMPRINCIPALPARC,
                          STAT.STATUSPARC AS TIPOPARC
                        FROM 
                          PARCNEGOCIO PARC
                          JOIN CRM_STATUSPARC STAT
                            ON STAT.NRPARCNEGOCIO = PARC.NRPARCNEGOCIO
                            AND STAT.NRORG = PARC.NRORG
                            AND CRM_NRORGTRAB = :CRM_NRORGTRAB
                        WHERE 
                          PARC.NRINSCRICAOPARC LIKE('%'|| :INSCRICAO || '%')
                          AND (PARC.NRPARCNEGOCIO <> :PKVALUE OR :PKVALUE IS NULL)
                          AND PARC.NRORG = :NRORG";
                      
            $std = $this->connection->prepare($select);
            $std->execute($paramsVerifyLeadCPNJ);
            $leads = $std->fetchAll();
            return $leads;
        } catch(\Exception $e) {
            throw $e;
        };
    }
    
    public function verifyLeadExactCNPJ($paramsVerifyLeadCPNJ){
        try{
            $select =  "SELECT 
                          PARC.NMPRINCIPALPARC,
                          STAT.STATUSPARC AS TIPOPARC
                        FROM 
                          PARCNEGOCIO PARC
                          JOIN CRM_STATUSPARC STAT
                            ON STAT.NRPARCNEGOCIO = PARC.NRPARCNEGOCIO
                            AND STAT.NRORG = PARC.NRORG
                            AND CRM_NRORGTRAB = :CRM_NRORGTRAB
                        WHERE 
                          PARC.NRINSCRICAOPARC = :INSCRICAO
                          AND (PARC.NRPARCNEGOCIO <> :PKVALUE OR :PKVALUE IS NULL)
                          AND PARC.NRORG = :NRORG";
                      
            $std = $this->connection->prepare($select);
            $std->execute($paramsVerifyLeadCPNJ);
            $leads = $std->fetchAll();
            return $leads;
        } catch(\Exception $e) {
            throw $e;
        };
    }
    
    public function verifyLeadName($paramsVerifyLeadName){
        if(!empty($paramsVerifyLeadName['NOME'])) {
            $select =  "SELECT 
                          PARC.NMPRINCIPALPARC,
                          STAT.STATUSPARC AS TIPOPARC
                        FROM 
                          PARCNEGOCIO PARC
                          JOIN CRM_STATUSPARC STAT
                            ON STAT.NRPARCNEGOCIO = PARC.NRPARCNEGOCIO
                            AND STAT.NRORG = PARC.NRORG
                            AND CRM_NRORGTRAB = :CRM_NRORGTRAB
                        WHERE 
                          UPPER(PARC.NMPRINCIPALPARC) LIKE UPPER(:NOME)
                          AND (PARC.NRPARCNEGOCIO <> :PKVALUE OR :PKVALUE IS NULL)
                          AND PARC.NRORG = :NRORG";
                          
            try{
                $std = $this->connection->prepare($select);
                $std->execute($paramsVerifyLeadName);
                $leads = $std->fetchAll();
                
                return $leads;
            } catch(\Exception $e) {
                throw $e;
            };
        } else {
            return array();
        }
    }
    
    public function parcRevalidation($params){
        try{
            $select =  "SELECT 
                          CRM_NRORGTRAB
                        FROM 
                          CRM_STATUSPARC
                        WHERE 
                          NRORG = :NRORG
                          AND NRPARCNEGOCIO = :NRPARCNEGOCIO";
                      
            $std = $this->connection->prepare($select);
            $std->execute($params);
            $orgs = $std->fetchAll();
            
            return $orgs;
        } catch(\Exception $e) {
            throw $e;
        };
    }
    
    public function verifyFilialOper($paramsVerifyFilial) {
        if(!empty($paramsVerifyFilial['CDOPEREVOL'])) {
            $select = "SELECT CDFILIAL, NRORG FROM FILIOPER
                        WHERE CDOPERADOR = :CDOPEREVOL
                        AND   NRORG = :NRORG";
            try{
                $std = $this->connection->prepare($select);
                $std->execute($paramsVerifyFilial);
                $filial = $std->fetchAll();
                
                return $filial;
            }
            catch(\Exception $e) {
                throw $e;
            };
        } else {
            return array();
        }
        
    }
    
    public function insertLeadEvolNextTask($paramsInsertLeadEvolNextTask) {

        $insert = "INSERT INTO FILACONTATO (DSFILACONTATO,DTPLANFILACONTA,CDOPERREAL,NRSEQFILACONTA,NRORG,DTINCLUSAO,NRORGINCLUSAO,
                               CDOPERINCLUSAO,NRPARCNEGOCIO,IDORIGFILACONTA,IDATIVO,NRCONTATO, NRPRIORFILACONT,NRSEQCONTATO, NRSEQCLASSIFICATAREFA, NRSEQINTERLOCUTOR, DSEMAILTAREFA, DSTELEFONETAREFA, CRM_NRORGTRAB)
                    VALUES (:DSFILACONTATO,
                            :DTPLANFILACONTA,
                            :CDOPERREAL,
                            :NRSEQFILACONTA,
                            :NRORG,
                             SYSDATE,
                            :NRORGINCLUSAO,
                            :CDOPERINCLUSAO,
                            :NRPARCNEGOCIO,
                             'M',
                             'S',
                            :NRCONTATO,
                            :NRPRIORFILACONT,
                            :NRSEQCONTATO,
                            :NRSEQCLASSIFICATAREFA,
                            :NRSEQINTERLOCUTOR,
                            :DSEMAILTAREFA,
                            :DSTELEFONETAREFA,
                            :CRM_NRORGTRAB)";
                 
        try{
            $std = $this->connection->prepare($insert);
            $std->execute($paramsInsertLeadEvolNextTask);
        } catch(\Exception $e) {
            throw $e;
        };
        
    }
       
    public function requestForSetTaskEndDate($paramsSetTaskEndDate){
        
        $update = "UPDATE FILACONTATO 
                   SET DTREALFILACONTA = SYSDATE
                   WHERE NRSEQFILACONTA = :NRSEQFILACONTA";
        
        try{
            $std = $this->connection->prepare($update);
            $std->execute($paramsSetTaskEndDate);
        } catch(\Exception $e) {
            throw $e;
        };
        
    }
    
    public function getLimiteLeadsPorRevendaParametrizacao($nrorg){
        
        $select = "SELECT DECODE(NRLIMITELEADREVENDA, NULL, 'SEM_LIMITE', NRLIMITELEADREVENDA) NRLIMITELEADREVENDA FROM CRM_PARAMETRIZACAO WHERE NRORG = '$nrorg'";
        
        try{
            $std = $this->connection->prepare($select);
            $std->execute();
            $limite = $std->fetchAll();
            
            if(is_array($limite)){
                return $limite[0]['NRLIMITELEADREVENDA'];
            }
            return $limite;
        } catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function getQuantidadeLeadsOperador($parcOperador, $nrorg){
        
        $select = "SELECT COUNT(NRCANDIDATO) QUANTIDADE FROM CRM_CANDIDATO WHERE NRORG = '$nrorg' AND NRPARCPROPRI = '$parcOperador' ";
        
        try{
            $std = $this->connection->prepare($select);
            $std->execute();
            $quantidadeOperador = $std->fetchAll();
            if(is_array($quantidadeOperador)){
                return $quantidadeOperador[0]['QUANTIDADE'];
            }
            return $quantidadeOperador;
        } catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function requestForDeactivateLeadTask($paramsDeactivateTask){
        
        $update = "UPDATE FILACONTATO 
                   SET IDATIVO = 'N'
                   WHERE NRSEQFILACONTA = :NRSEQFILACONTA";
        
        try{
            $std = $this->connection->prepare($update);
            $std->execute($paramsDeactivateTask);
        } catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function requestForInsertProspectInterlocutor($paramsInsertInterlocutor){
        
        $insertInterlocutor = "INSERT INTO CRM_INTERLOCUTOR ( NRSEQINTERLOCUTOR, NMINTERLOCUTOR, 
        NRPARCNEGOCIO, CDCARGOINTERLOC, IDRECEBEPRESENTE, EMAILINTERLOC, NRTELEFONE1, DTINCLUSAO, NRORG)
                               VALUES(:NRSEQINTERLOCUTOR,
                                      :NMINTERLOCUTOR,
                                      :NRPARCNEGOCIO,
                                      :CDCARGOINTERLOC,
                                      :IDRECEBEPRESENTE,
                                      :EMAILINTERLOC,
                                      :NRTELEFONE1,
                                       SYSDATE,
                                      :NRORG)";
        
        try{
            $std = $this->connection->prepare($insertInterlocutor);
            $std->execute($paramsInsertInterlocutor);
        } catch(\Exception $e){
            throw $e;
        };
        
    } 
    
    public function requestToSetLeadIdAtivo($updateParams){
    
        $updateLead = "UPDATE 
                         CRM_STATUSPARC 
                       SET 
                         IDATIVO = :IDATIVO
                       WHERE 
                         NRPARCNEGOCIO = :NRPARCNEGOCIO
                         AND NRORG = :NRORG
                         AND CRM_NRORGTRAB = :CRM_NRORGTRAB";
        
        try{
            $std = $this->connection->prepare($updateLead);
            $std->execute($updateParams);
        }catch(Exception $e){
            throw $e;
        }
    }
    
    public function getLimiteProspectsPorOperadorParametrizacao($nrorg){
        
        $select = "SELECT DECODE(NRLIMITEPROSPOPER, NULL, 'SEM_LIMITE', NRLIMITEPROSPOPER) NRLIMITEPROSPOPER FROM CRM_PARAMETRIZACAO WHERE NRORG = '$nrorg'";
        
        try{
            $std = $this->connection->prepare($select);
            $std->execute();
            $limite = $std->fetchAll();
            
            if(!empty($limite)){
                return $limite[0]['NRLIMITEPROSPOPER'];
            }
            return $limite;
        } catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function getQuantidadeProspectsOperador($parcOperador, $nrorg){
        
        $select = "SELECT COUNT(CDPROSPECT) QUANTIDADE FROM PROSPECT WHERE NRORG = '$nrorg' AND NRPARCRESPROSP = '$parcOperador' ";
        
        try{
            $std = $this->connection->prepare($select);
            $std->execute();
            $quantidadeOperador = $std->fetchAll();
            if(is_array($quantidadeOperador)){
                return $quantidadeOperador[0]['QUANTIDADE'];
            }
            return $quantidadeOperador;
        } catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function requestToInsertProspectToResale($paramsInsert) {
        
        $insert = "INSERT INTO CRM_PROSPREVENDA 
                    (NRPROSPREVENDA, NRREVENDA, CDPROSPECT, NRPARCNEGOCIO, NRORG, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, IDATIVO)
                    VALUES(
                        :NRPROSPREVENDA,
                        :NRREVENDA,
                        :CDPROSPECT,
                        :NRPARCNEGOCIO,
                        :NRORG,
                        SYSDATE,
                        :NRORG,
                        :CDOPERINCLUSAO,
                        :IDATIVO)";
        
        $std = $this->connection->prepare($insert);
        $std->execute($paramsInsert);
        
    }
    
    public function requestToUpdateLeadPartnership($params){
        
        $sql = "INSERT INTO PARCERIA
                    (NRPARCERIA, NRPARCNEGOCIO, CDTIPOPARCEIRO, NRORG,
                    IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO)
                
                VALUES(:NRPARCERIA, :NRPARCNEGOCIO, 'PROSPECT', :NRORG,
                    'S', SYSDATE, :NRORG, :CDOPERADOR)";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
    }
    
    public function requestToGetLeadPartnershipNumber($selectParams){
        
        $select = "SELECT NRPARCERIA
                   FROM PARCERIA
                   WHERE NRPARCNEGOCIO = :NRPARCNEGOCIO
                   AND CDTIPOPARCEIRO = :CDTIPOPARCEIRO
                   AND NRORG = :NRORG";
        
        
        $std = $this->connection->prepare($select);
        $std->execute($selectParams);
        $partnershipNumber = $std->fetchAll();
        
        return $partnershipNumber;
        
    }
    
    public function requestToEditLeadResponsibleOperator($updateParams){
        
        $update = "UPDATE CRM_CANDIDATO
                   SET NRPARCPROPRI = :NEWNRPARCPROPRI
                   WHERE NRCANDIDATO = :NRCANDIDATO
                   AND NRORG = :NRORG";
        
        $std = $this->connection->prepare($update);
        $std->execute($updateParams);
        
    }
    
    public function updateEnderecoParc($updateParams){
        
        $update = "UPDATE ENDERECOPARC
                   SET CDPAIS = :CDPAIS, SGESTADO = :SGESTADO, CDMUNICIPIO = :CDMUNICIPIO, CDBAIRRO = :CDBAIRRO, NRCEPENDERECO = :NRCEPENDERECO, DSENDERECO = :DSENDERECO, NRIMOVELENDERECO =  :NRIMOVELENDERECO, DSCOMPLEENDERECO =  :DSCOMPLEENDERECO
                   WHERE NRPARCNEGOCIO = :NRPARCNEGOCIO
                   AND NRENDERECOPARC = :NRENDERECOPARC
                   AND NRORG = :NRORG";
        
        $std = $this->connection->prepare($update);
        $std->execute($updateParams);
        
    }
    
    public function insertEnderecoParc($paramsInsert) {
        
        $insert = "INSERT INTO ENDERECOPARC 
                    (NRENDERECOPARC, NRPARCNEGOCIO, CDTIPOENDERECO, NRORG, IDATIVO, CDPAIS, SGESTADO, CDMUNICIPIO, CDBAIRRO, NRCEPENDERECO, DSENDERECO, NRIMOVELENDERECO, DSCOMPLEENDERECO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO)
                    VALUES(
                        :NRENDERECOPARC,
                        :NRPARCNEGOCIO,
                        'PRINCIPAL',
                        :NRORG,
                        :IDATIVO,
                        :CDPAIS,
                        :SGESTADO,
                        :CDMUNICIPIO,
                        :CDBAIRRO,
                        :NRCEPENDERECO,
                        :DSENDERECO,
                        :NRIMOVELENDERECO,
                        :DSCOMPLEENDERECO,
                        SYSDATE,
                        :NRORG,
                        :CDOPERINCLUSAO)";
        
        $std = $this->connection->prepare($insert);
        $std->execute($paramsInsert);
        
    }
    
    public function selectEnderecoparc($nrParcnegocio, $nrOrg){
        
        $select = "SELECT NRENDERECOPARC
                   FROM ENDERECOPARC
                   WHERE NRPARCNEGOCIO = $nrParcnegocio
                   AND CDTIPOENDERECO = 'PRINCIPAL'
                   AND NRORG = $nrOrg";
        
        
        $std = $this->connection->prepare($select);
        $std->execute();
        $nrEnderecoParc = $std->fetchAll();
        
        return $nrEnderecoParc;
        
    }
    
    public function getComunicaparc($paramsGetNrparcEstrutura){

        $update = "SELECT CDCOMUNICAPARC FROM COMUNICAPARC
                        WHERE CDCOMUNICAPARC = :CDCOMUNICAPARC 
                            AND CDFORMACOMU IN (:CDFORMACOMU)
                            AND NRPARCNEGOCIO = :NRPARCNEGOCIO
                            AND NRORG = :NRORG";
                 
        try{
            $std = $this->connection->prepare($update);
            $std->execute($paramsGetNrparcEstrutura);
            $return = $std->fetchAll();
            if(!empty($return))
                return $return[0]['CDCOMUNICAPARC'];
            else 
                return array();
            
        } catch(\Exception $e){
            throw $e;
        };
    }
    
    public function getTelPrinc($paramsGetNrparcEstrutura){

        $update = "SELECT 
                     CDCOMUNICAPARC 
                   FROM 
                     COMUNICAPARC
                   WHERE 
                     CDFORMACOMU = :CDFORMACOMU
                     AND NRPARCNEGOCIO = :NRPARCNEGOCIO
                     AND NRORG = :NRORG";
                 
        try{
            $std = $this->connection->prepare($update);
            $std->execute($paramsGetNrparcEstrutura);
            $return = $std->fetchAll();
            if(!empty($return))
                return $return[0]['CDCOMUNICAPARC'];
            else 
                return array();
            
        } catch(\Exception $e){
            throw $e;
        };
    }
    
    public function updateTelPrinc($paramsGetNrparcEstrutura){

        $update = "UPDATE 
                     COMUNICAPARC 
                   SET 
                     CDCOMUNICAPARC = :CDCOMUNICAPARC
                   WHERE 
                     NRPARCNEGOCIO = :NRPARCNEGOCIO
                     AND NRORG = :NRORG
                     AND CDFORMACOMU = '01'";
                 
        try{
            $std = $this->connection->prepare($update);
            $std->execute($paramsGetNrparcEstrutura);
            $return = $std->fetchAll();
            if(!empty($return))
                return $return[0]['CDCOMUNICAPARC'];
            else 
                return array();
            
        } catch(\Exception $e){
            throw $e;
        };
    }
    
    public function insertComunicaparc($paramsInserComunica){

        $update = "INSERT INTO COMUNICAPARC (CDCOMUNICAPARC, IDATIVO, DTINCLUSAO, NRCOMUNICAPARC, NRPARCNEGOCIO, CDFORMACOMU, NRORG)
                    VALUES (:CDCOMUNICAPARC, :IDATIVO, SYSDATE, :NRCOMUNICAPARC, :NRPARCNEGOCIO, :CDFORMACOMU, :NRORG)";
                 
        try{
            $std = $this->connection->prepare($update);
            $std->execute($paramsInserComunica);
            return true;
        } catch(\Exception $e){
            throw $e;
        };
    }
    
    public function saveDtnascifundparc($params){
        
        $update = "UPDATE PARCNEGOCIO
                   SET DTNASCIFUNDPARC = :DTNASCIFUNDPARC
                   WHERE NRPARCNEGOCIO = :NRPARCNEGOCIO
                   AND NRORG = :NRORG";
        
        $std = $this->connection->prepare($update);
        $std->execute($params);
        
    }
    
    public function insertNewInterlocutor($paramsNewInterlocutor){
         $insertInterlocutor = "INSERT INTO CRM_INTERLOCUTOR (NRSEQINTERLOCUTOR, NMINTERLOCUTOR, NRTELEFONE1, EMAILINTERLOC, NRPARCNEGOCIO, NRORG, IDATIVO, DTINCLUSAO)
                    VALUES (:NRSEQINTERLOCUTOR,
                            :NMINTERLOCUTOR,
                            :NRTELEFONE1,
                            :EMAILINTERLOC,
                            :NRPARCNEGOCIO,
                            :NRORG,
                            :IDATIVO,
                            SYSDATE)";
                 
        try{
            $std = $this->connection->prepare($insertInterlocutor);
            $std->execute($paramsNewInterlocutor);
            return true;
        } catch(\Exception $e){
            throw $e;
        };
    }
    
    public function verifyExistentPartnership($nrparcnegocio, $cdtipoparceria, $nrorg) {
         try{
            $query = "SELECT 
                        * 
                      FROM 
                        PARCERIA 
                      WHERE 
                        NRPARCNEGOCIO = :P_NRPARCNEGOCIO 
                        AND CDTIPOPARCEIRO = :P_CDTIPOPARCEIRO 
                        AND NRORG = :P_NRORG";
            
            $params = array(
                "P_NRPARCNEGOCIO"   => $nrparcnegocio,
                "P_CDTIPOPARCEIRO"  => $cdtipoparceria,
                "P_NRORG"           => $nrorg
            );
            
            $std = $this->connection->prepare($query);
            $std->execute($params);
            $return = $std->fetchAll();
            if(empty($return)) {
                return true;
            } else {
                return false;
            }
        }catch(\Exception $e) {
            throw $e;
        };
    }
    
    public function verifyExistentProspect($nrparcnegocio, $nrorg) {
        try{
            $query = "SELECT 
                        * 
                      FROM 
                        PROSPECT 
                      WHERE 
                        NRPARCNEGOCIO = :P_NRPARCNEGOCIO 
                        AND NRORG = :P_NRORG";
            
            $params = array(
                "P_NRPARCNEGOCIO"   => $nrparcnegocio,
                "P_NRORG"           => $nrorg
            );
            
            $std = $this->connection->prepare($query);
            $std->execute($params);
            $return = $std->fetchAll();
            if(empty($return)) {
                return true;
            } else {
                return false;
            }
        }catch(\Exception $e) {
            throw $e;
        };
    }
   
    public function verificaParceiro($row){
        try{
            $razSoc;
            $nomFant;
            if(isset($row['NMCANDIDATO'])) {
                $razSoc = $row['NMCANDIDATO'];
                $nomFant = $row['NMFANTCAN'];
            } else if(isset($row['NMRAZSOCPROS'])) {
                $razSoc = $row['NMRAZSOCPROS'];
                $nomFant = $row['NMFANTPROS'];
            } else if(isset($row['NMRAZSOCCLIE'])) {
                $razSoc = $row['NMRAZSOCCLIE'];
                $nomFant = $row['NMFANTCLIE'];
            }
            if(empty($row['INSCRICAO'])) {
                if(isset($row['IDBLOQNOMESEMELHA']) && $row['IDBLOQNOMESEMELHA'] == 'S') {
                    $find= "SELECT 
                              *
                            FROM 
                              CRM_STATUSPARC
                            WHERE 
                              NRPARCNEGOCIO = (SELECT MAX(NRPARCNEGOCIO) FROM PARCNEGOCIO WHERE UPPER(NMPRINCIPALPARC) = UPPER(:NMPRINCIPALPARC) AND UPPER(NMSECUNDARIPARC) = UPPER(:NMSECUNDARIPARC) AND NRORG = :NRORG)
                              AND NRORG = :NRORG";
                    
                    $params = array (
                        "NMPRINCIPALPARC"  => $razSoc,
                        "NMSECUNDARIPARC"  => $nomFant,
                        "NRORG"            => $row["NRORG"]
                    );
                }
            } else {
                if($row['IDTPIJURCAN'] === 'J') {
                    $find= "SELECT 
                              *
                            FROM 
                              CRM_STATUSPARC
                            WHERE 
                              NRPARCNEGOCIO = (SELECT MAX(NRPARCNEGOCIO) FROM PARCNEGOCIO WHERE NRINSCRICAOPARC LIKE ('%' || :INSCRICAO || '%') AND NRORG = :NRORG)
                              AND NRORG = :NRORG";
                } else {
                    $find= "SELECT 
                              *
                            FROM 
                              CRM_STATUSPARC
                            WHERE 
                              NRPARCNEGOCIO = (SELECT MAX(NRPARCNEGOCIO) FROM PARCNEGOCIO WHERE NRINSCRICAOPARC = :INSCRICAO AND NRORG = :NRORG)
                              AND NRORG = :NRORG";
                }
                
                $params = array (
                    "INSCRICAO"    => $row["INSCRICAO"],
                    "NRORG"        => $row["NRORG"]
                );
            }
            
            if(!empty($find)) {
                $std = $this->connection->prepare($find);
                $std->execute($params);
                $return = $std->fetchAll();
            }
            
            if(isset($return) && !empty($return)) {
                return $this->buscarDadosParc($return[0]['NRPARCNEGOCIO'], $row["NRORG"], $row['CRM_NRORGTRAB']);
            } else {
                return false;
            }
            
        } catch(\Exception $e){
            throw $e;
        };
    }
    
    public function insertStatusParc($row, $params = null){
        try{
            $insert =  "INSERT INTO 
                        CRM_STATUSPARC(NRPARCNEGOCIO,
                                       NRPARCRESP,
                                       CDOPERRESP,
                                       STATUSPARC,
                                       NRORG,
                                       CRM_NRORGTRAB,
                                       IDATIVO,
                                       DTINCLUSAO,
                                       DTULTATU,
                                       NRORGINCLUSAO,
                                       CDOPERINCLUSAO,
                                       NRORGULTATU,
                                       CDOPERULTATU,
                                       IDSTATUS)
                        VALUES (:NRPARCNEGOCIO,
                                :NRPARCRESP,
                                :CDOPERRESP,
                                :CDTIPOPARCPRINCIPAL,
                                :NRORG,
                                :CRM_NRORGTRAB,
                                :IDATIVO,
                                SYSDATE,
                                SYSDATE,
                                :NRORG,
                                :CDOPERINCLUSAO,
                                :NRORG,
                                :CDOPERINCLUSAO,
                                :IDSTATUS)";
            
            if(empty($params)) {
                $params = array(
                    "NRPARCNEGOCIO"         => $row["NRPARCNEGOCIO"],
                    "NRPARCRESP"            => $row["NRPARCRESP"],
                    "CDOPERRESP"            => $row["CDOPERRESPONSAVEL"],
                    "CDTIPOPARCPRINCIPAL"   => $row["CDTIPOPARCEIRO"],
                    "NRORG"                 => $row["NRORG"],
                    "CRM_NRORGTRAB"         => $row["CRM_NRORGTRAB"],
                    "IDATIVO"               => $row["IDATIVO"],
                    "CDOPERINCLUSAO"        => $row["CDOPERINCLUSAO"],
                    "IDSTATUS"              => $row["IDSTATUS"]
                );
            }
            
            $std = $this->connection->prepare($insert);
            $std->execute($params);
            return true;
        } catch(\Exception $e) {
            throw $e;
        };
    }
    
    public function updateStatusProsp($row) {
        try{
            $insert =  "UPDATE 
                          CRM_STATUSPARC
                        SET 
                          STATUSPARC      = :CDTIPOPARCPRINCIPAL,
                          IDATIVO         = :IDATIVO,
                          DTULTATU        = SYSDATE,
                          CDOPERULTATU    = :CDOPERULTATU,
                          IDSTATUS        = NULL
                        WHERE 
                          NRPARCNEGOCIO = :NRPARCNEGOCIO
                          AND NRORG = :NRORG
                          AND CRM_NRORGTRAB = :CRM_NRORGTRAB";
            
            $params = array(
                "IDATIVO"              => $row["IDATIVO"],
                "NRPARCNEGOCIO"        => $row["NRPARCNEGOCIO"],
                "NRORG"                => $row["NRORG"],
                "CDOPERULTATU"         => $row["CDOPERULTATU"],
                "CRM_NRORGTRAB"        => $row["CRM_NRORGTRAB"],
                "CDTIPOPARCPRINCIPAL"  => "PROSPECT"
            );
            
            $std = $this->connection->prepare($insert);
            $std->execute($params);
        } catch(\Exception $e){
            throw $e;
        };
    }
    
    public function buscarDadosParc($nrparcnegocio, $nrorg, $crm_nrorgtrab) {
        try{
            $findcand = "SELECT 
                           *
                         FROM 
                           CRM_CANDIDATO
                         WHERE 
                           NRPARCNEGOCIO = :NRPARCNEGOCIO
                           AND NRORG = :NRORG";
            
            $findpros = "SELECT 
                           *
                         FROM 
                           PROSPECT
                         WHERE 
                           NRPARCNEGOCIO = :NRPARCNEGOCIO
                           AND NRORG = :NRORG";
            $findclie = "SELECT 
                           *
                         FROM 
                           CLIENTE
                         WHERE 
                           NRPARCNEGOCIO = :NRPARCNEGOCIO
                           AND NRORG = :NRORG";
                
            $params = array (
                "NRPARCNEGOCIO"  => $nrparcnegocio,
                "NRORG"          => $nrorg
            );
            
            $verifyOnlyOrg = "SELECT
                                *
                              FROM
                                CRM_STATUSPARC
                              WHERE
                                CRM_NRORGTRAB <> :CRM_NRORGTRAB
                                AND NRPARCNEGOCIO = :NRPARCNEGOCIO
                                AND NRORG = :NRORG";
                                
            $paramsOrg = array (
                "NRPARCNEGOCIO"  => $nrparcnegocio,
                "NRORG"          => $nrorg,
                "CRM_NRORGTRAB"  => $crm_nrorgtrab
            );
            
            // busca os dados de na direção cliente -> Lead com a intenção de ter os dados mais atualizados 
            $std = $this->connection->prepare($findclie);
            $std->execute($params);
            $cliente = $std->fetchAll();
            $std2 = $this->connection->prepare($findpros);
            $std2->execute($params);
            $prospect = $std2->fetchAll();
            $std3 = $this->connection->prepare($findcand);
            $std3->execute($params);
            $lead = $std3->fetchAll();
            $std4 = $this->connection->prepare($verifyOnlyOrg);
            $std4->execute($paramsOrg);
            $exlusiveParc = empty($std4->fetchAll()) ? true : false;
            
            if(!empty($cliente)) {
                if(!empty($lead)) {
                    $cliente[0]['NRCANDIDATO'] = $lead[0]['NRCANDIDATO'];
                    $cliente[0]['DESCTITULOCAN'] = $lead[0]['DESCTITULOCAN'];
                    $cliente[0]['NRCONTATO'] = $lead[0]['NRCONTATO'];
                    $cliente[0]['NRSEQCONTATO'] = $lead[0]['NRSEQCONTATO'];
                    $cliente[0]['LEADEXISTS'] = true;
                } else {
                    $cliente[0]['IDPARCFUNDIDO'] = 'N';
                    $cliente[0]['IDSTATUSCAN'] = 3;
                    $cliente[0]['LEADEXISTS'] = false;
                }
                if(!empty($prospect)) {
                    $cliente[0]['PROSPEXISTS'] = true;
                } else {
                    $cliente[0]['PROSPEXISTS'] = false;
                }
                $cliente[0]['NRINSJURCAN'] = $cliente[0]['NRINSJURCLIE'];
                $cliente[0]['NRINSJURPROS'] = $cliente[0]['NRINSJURCLIE'];
                $cliente[0]['EXCLUSIVEPARC'] = $exlusiveParc;

                $comunicaParc = $this->findEmailAndTel($nrparcnegocio, $nrorg);
                $cliente[0]['DSEMAILCAN'] = !empty($comunicaParc['EMAIL']) ? $comunicaParc['EMAIL']['CDCOMUNICAPARC'] : "";
                $cliente[0]['DSTELEFONECAN'] = !empty($comunicaParc['TELEFONE']) ? $comunicaParc['TELEFONE']['CDCOMUNICAPARC'] : "";
                
                $enderecoParc = $this->returnParcAddress($cliente[0]['NRPARCNEGOCIO'], $cliente[0]['NRORG']);
                if(!empty($enderecoParc)) {
                    $enderecoParc = $enderecoParc[0];
                    $cliente[0]['CDPAIS'] = $enderecoParc['CDPAIS'];
                    $cliente[0]['NMPAIS'] = $enderecoParc['NMPAIS'];
                    $cliente[0]['SGESTADO'] = $enderecoParc['SGESTADO'];
                    $cliente[0]['NMESTADO'] = $enderecoParc['NMESTADO'];
                    $cliente[0]['CDMUNICIPIO'] = $enderecoParc['CDMUNICIPIO'];
                    $cliente[0]['NMMUNICIPIO'] = $enderecoParc['NMMUNICIPIO'];
                    $cliente[0]['CDBAIRRO'] = $enderecoParc['CDBAIRRO'];
                    $cliente[0]['NMBAIRRO'] = $enderecoParc['NMBAIRRO'];
                    $cliente[0]['NRIMOVELENDERECO'] = $enderecoParc['NRIMOVELENDERECO'];
                    $cliente[0]['CDBAIRRO'] = $enderecoParc['CDBAIRRO'];
                    $cliente[0]['NRCEPENDERECO'] = $enderecoParc['NRCEPENDERECO'];
                    $cliente[0]['DSCOMPLEENDERECO'] = $enderecoParc['DSCOMPLEENDERECO'];
                    $cliente[0]['DSENDERECO'] = $enderecoParc['DSENDERECO'];
                }
                if(!empty($cliente[0]['CDSEGMER'])) {
                    $segmer = $this->searchSegMerc($cliente[0]['CDSEGMER'], $cliente[0]['NRORG']);
                    if($segmer) {
                        $cliente[0]['DSSEGMER'] = $segmer['DSSEGMER'];
                    }
                }
                return $cliente[0];
            } else if(!empty($prospect)) {
                if(!empty($lead)) {
                    $prospect[0]['NRCANDIDATO'] = $lead[0]['NRCANDIDATO'];
                    $prospect[0]['DESCTITULOCAN'] = $lead[0]['DESCTITULOCAN'];
                    $prospect[0]['LEADEXISTS'] = true;
                    $prospect[0]['NRCONTATO'] = $lead[0]['NRCONTATO'];
                    $prospect[0]['NRSEQCONTATO'] = $lead[0]['NRSEQCONTATO'];
                } else {
                    $prospect[0]['IDSTATUSCAN'] = 3;
                    if(empty($prospect[0]['IDPARCFUNDIDO'])) {
                        $prospect[0]['IDPARCFUNDIDO'] = 'N';
                    }
                    $prospect[0]['LEADEXISTS'] = false;
                }
                $prospect[0]['NRINSJURCAN'] = $prospect[0]['NRINSJURPROS'];
                $prospect[0]['EXCLUSIVEPARC'] = $exlusiveParc;
                
                $comunicaParc = $this->findEmailAndTel($nrparcnegocio, $nrorg);
                $prospect[0]['DSEMAILCAN'] = !empty($comunicaParc['EMAIL']) ? $comunicaParc['EMAIL']['CDCOMUNICAPARC'] : "";
                $prospect[0]['DSTELEFONECAN'] = !empty($comunicaParc['TELEFONE']) ? $comunicaParc['TELEFONE']['CDCOMUNICAPARC'] : "";
                
                $enderecoParc = $this->returnParcAddress($prospect[0]['NRPARCNEGOCIO'], $prospect[0]['NRORG']);
                if(!empty($enderecoParc)) {
                    $enderecoParc = $enderecoParc[0];
                    $prospect[0]['CDPAIS'] = $enderecoParc['CDPAIS'];
                    $prospect[0]['NMPAIS'] = $enderecoParc['NMPAIS'];
                    $prospect[0]['SGESTADO'] = $enderecoParc['SGESTADO'];
                    $prospect[0]['NMESTADO'] = $enderecoParc['NMESTADO'];
                    $prospect[0]['CDMUNICIPIO'] = $enderecoParc['CDMUNICIPIO'];
                    $prospect[0]['NMMUNICIPIO'] = $enderecoParc['NMMUNICIPIO'];
                    $prospect[0]['CDBAIRRO'] = $enderecoParc['CDBAIRRO'];
                    $prospect[0]['NMBAIRRO'] = $enderecoParc['NMBAIRRO'];
                    $prospect[0]['NRIMOVELENDERECO'] = $enderecoParc['NRIMOVELENDERECO'];
                    $prospect[0]['CDBAIRRO'] = $enderecoParc['CDBAIRRO'];
                    $prospect[0]['NRCEPENDERECO'] = $enderecoParc['NRCEPENDERECO'];
                    $prospect[0]['DSCOMPLEENDERECO'] = $enderecoParc['DSCOMPLEENDERECO'];
                    $prospect[0]['DSENDERECO'] = $enderecoParc['DSENDERECO'];
                }
                if(!empty($prospect[0]['CDSEGMER'])) {
                    $segmer = $this->searchSegMerc($prospect[0]['CDSEGMER'], $prospect[0]['NRORG']);
                    if($segmer) {
                        $prospect[0]['DSSEGMER'] = $segmer['DSSEGMER'];
                    }
                }
                return $prospect[0];
            } else if(!empty($lead)) {
                $lead[0]['EXCLUSIVEPARC'] = $exlusiveParc;
                $enderecoParc = $this->returnParcAddress($lead[0]['NRPARCNEGOCIO'], $lead[0]['NRORG']);
                if(!empty($enderecoParc)) {
                    $enderecoParc = $enderecoParc[0];
                    $lead[0]['CDPAIS'] = $enderecoParc['CDPAIS'];
                    $lead[0]['NMPAIS'] = $enderecoParc['NMPAIS'];
                    $lead[0]['SGESTADO'] = $enderecoParc['SGESTADO'];
                    $lead[0]['NMESTADO'] = $enderecoParc['NMESTADO'];
                    $lead[0]['CDMUNICIPIO'] = $enderecoParc['CDMUNICIPIO'];
                    $lead[0]['NMMUNICIPIO'] = $enderecoParc['NMMUNICIPIO'];
                    $lead[0]['CDBAIRRO'] = $enderecoParc['CDBAIRRO'];
                    $lead[0]['NMBAIRRO'] = $enderecoParc['NMBAIRRO'];
                    $lead[0]['NRIMOVELENDERECO'] = $enderecoParc['NRIMOVELENDERECO'];
                    $lead[0]['CDBAIRRO'] = $enderecoParc['CDBAIRRO'];
                    $lead[0]['NRCEPENDERECO'] = $enderecoParc['NRCEPENDERECO'];
                    $lead[0]['DSCOMPLEENDERECO'] = $enderecoParc['DSCOMPLEENDERECO'];
                    $lead[0]['DSENDERECO'] = $enderecoParc['DSENDERECO'];
                }
                $comunicaParc = $this->findEmailAndTel($nrparcnegocio, $nrorg);
                $lead[0]['DSEMAILCAN'] = !empty($comunicaParc['EMAIL']) ? $comunicaParc['EMAIL']['CDCOMUNICAPARC'] : "";
                $lead[0]['DSTELEFONECAN'] = !empty($comunicaParc['TELEFONE']) ? $comunicaParc['TELEFONE']['CDCOMUNICAPARC'] : "";
                return $lead[0];
            }
            
        } catch(\Exception $e){
            throw $e;
        };
    }
    
    public function verificaProspect($nrparcnegocio, $nrorg) {
        try{
            $find= "SELECT 
                      *
                    FROM 
                      PROSPECT
                    WHERE 
                      NRPARCNEGOCIO = :NRPARCNEGOCIO
                      AND NRORG = :NRORG";
            
            $params = array (
                "NRPARCNEGOCIO"  => $nrparcnegocio,
                "NRORG"          => $nrorg
            );
            
            $std = $this->connection->prepare($find);
            $std->execute($params);
            $return = $std->fetchAll();
            
            return $return;
            
        } catch(\Exception $e){
            throw $e;
        };
    }
    
    public function returnParcAddress($nrparcnegocio, $nrorg) {
        try {
            $find= "SELECT 
                      ENDERECOPARC.*,
                      PAIS.NMPAIS,
                      ESTADO.NMESTADO,
                      MUNICIPIO.NMMUNICIPIO,
                      BAIRRO.NMBAIRRO
                    FROM 
                      ENDERECOPARC
                      LEFT JOIN PAIS
                        ON PAIS.CDPAIS = ENDERECOPARC.CDPAIS
                      LEFT JOIN ESTADO
                        ON ESTADO.CDPAIS = ENDERECOPARC.CDPAIS
                          AND ESTADO.SGESTADO = ENDERECOPARC.SGESTADO
                      LEFT JOIN MUNICIPIO
                        ON MUNICIPIO.CDPAIS = ENDERECOPARC.CDPAIS
                          AND MUNICIPIO.SGESTADO = ENDERECOPARC.SGESTADO
                          AND MUNICIPIO.CDMUNICIPIO = ENDERECOPARC.CDMUNICIPIO
                      LEFT JOIN BAIRRO
                        ON BAIRRO.CDPAIS = ENDERECOPARC.CDPAIS
                          AND BAIRRO.SGESTADO = ENDERECOPARC.SGESTADO
                          AND BAIRRO.CDMUNICIPIO = ENDERECOPARC.CDMUNICIPIO
                          AND BAIRRO.CDBAIRRO = ENDERECOPARC.CDBAIRRO
                    WHERE 
                      ENDERECOPARC.NRPARCNEGOCIO = :NRPARCNEGOCIO
                      AND ENDERECOPARC.NRORG = :NRORG
                      AND ENDERECOPARC.CDTIPOENDERECO = 'PRINCIPAL'
                      AND ROWNUM = 1";
            
            $params = array (
                "NRPARCNEGOCIO"  => $nrparcnegocio,
                "NRORG"          => $nrorg
            );
            
            $std = $this->connection->prepare($find);
            $std->execute($params);
            $return = $std->fetchAll();
            
            return $return;
            
        } catch(\Exception $e) {
            throw $e;
        };
    }
    
    
    public function searchForParc($row) {
        try {
            if(isset($row['INSCRICAO']) && !empty($row['INSCRICAO'])) {
                $find= "SELECT 
                          *
                        FROM 
                          PARCNEGOCIO
                        WHERE 
                          NRINSCRICAOPARC = :P_NRINSCRICAOPARC
                          AND NRORG = :P_NRORG";
                
                $params = array (
                    "P_NRINSCRICAOPARC"  => $row['INSCRICAO'],
                    "P_NRORG"            => $row['NRORG']
                );
                
                $std = $this->connection->prepare($find);
                $std->execute($params);
                $return = $std->fetchAll();
            }
            
            if(!isset($return) && empty($return)) {
                if(isset($row['NMCANDIDATO'])) {
                    $razSoc = $row['NMCANDIDATO'];
                } else if(isset($row['NMRAZSOCPROS'])) {
                    $razSoc = $row['NMRAZSOCPROS'];
                } else if(isset($row['NMRAZSOCCLIE'])) {
                    $razSoc = $row['NMRAZSOCCLIE'];
                } else {
                    return;
                }
                
                $find= "SELECT 
                          *
                        FROM 
                          PARCNEGOCIO
                        WHERE 
                          NMPRINCIPALPARC = :P_NMPRINCIPALPARC
                          AND NRORG = :P_NRORG";
                
                $params = array (
                    "P_NMPRINCIPALPARC"  => $razSoc,
                    "P_NRORG"            => $row['NRORG']
                );
                
                $std = $this->connection->prepare($find);
                $std->execute($params);
                $return = $std->fetchAll();
            }
            
            if(!empty($return)) {
                return $this->buscarDadosParc($return[0]['NRPARCNEGOCIO'], $return[0]['NRORG'], $row['CRM_NRORGTRAB']);
            } else {
                return array();
            }
            
        } catch(\Exception $e) {
            throw $e;
        };
    }
    
    public function searchSegMerc($cdSegMer, $nrorg) {
        try {
            $find= "SELECT 
                      *
                    FROM 
                      SEGMERCADO
                    WHERE 
                      CDSEGMER = :P_CDSEGMER
                      AND NRORG = :P_NRORG";
            
            $params = array (
                "P_CDSEGMER"  => $cdSegMer,
                "P_NRORG"     => $nrorg
            );
            
            $std = $this->connection->prepare($find);
            $std->execute($params);
            $return = $std->fetchAll();
            
            if(empty($return)) {
                return false;
            } else {
                return $return[0];
            }
        } catch(\Exception $e) {
            throw $e;
        };
    }
    
    public function findEmailAndTel($parcnegocio, $nrorg) {
        try {
            $findEmail = "SELECT 
                            CDCOMUNICAPARC 
                          FROM 
                            COMUNICAPARC
                          WHERE 
                            CDFORMACOMU = '05'
                            AND NRPARCNEGOCIO = :NRPARCNEGOCIO
                            AND NRORG = :NRORG
                            AND ROWNUM = 1";
            
            $params = array (
                "NRORG"          => $nrorg,
                "NRPARCNEGOCIO"  => $parcnegocio
            );
            
            $std = $this->connection->prepare($findEmail);
            $std->execute($params);
            $firstReturn = $std->fetchAll();
            
            
            $findTelef = "SELECT 
                            CDCOMUNICAPARC 
                          FROM 
                            COMUNICAPARC
                          WHERE 
                            CDFORMACOMU = '01'
                            AND NRPARCNEGOCIO = :NRPARCNEGOCIO
                            AND NRORG = :NRORG
                            AND ROWNUM = 1";
            
            
            $std = $this->connection->prepare($findTelef);
            $std->execute($params);
            $secondReturn = $std->fetchAll();
            
            if(!empty($firstReturn) && !empty($secondReturn)) {
                return array("TELEFONE" => $secondReturn[0], "EMAIL" => $firstReturn[0]);
            } else if(!empty($firstReturn) && empty($secondReturn)) {
                return array("TELEFONE" => array(), "EMAIL" => $firstReturn[0]);
            } else if (empty($firstReturn) && !empty($secondReturn)) {
                return array("TELEFONE" => $secondReturn[0], "EMAIL" => array());
            } else {
                return array();
            }
        } catch(\Exception $e) {
            throw $e;
        };
    }
    
    public function fundeParceiro($row) {
        try {
            $sqlMax = "SELECT MAX(NRSEQFUSAO+1) AS NRSEQFUSAO FROM CRM_FUSAO_PARC WHERE NRORG = :NRORG";
            
            $paramsMax = array (
                "NRORG"  => $row['NRORG']
            );
            
            $stdMax = $this->connection->prepare($sqlMax);
            $stdMax->execute($paramsMax);
            $seq = $stdMax->fetchAll()[0]['NRSEQFUSAO'];
            
            $sqlFusao= "INSERT INTO 
                        CRM_FUSAO_PARC(NRSEQFUSAO, CDOPERDESFUSAO, DTDESFUSAO, NRPARCORI, NRPARCDEST, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO)
                        VALUES(:NRSEQFUSAO, NULL, NULL, :ORIGEM, :DESTINO, :NRORG, SYSDATE, SYSDATE, :NRORG, :CDOPERADOR, :NRORG, :CDOPERADOR, 'S')";
            
            $paramsFusao = array (
                "NRSEQFUSAO"     => $seq,
                "ORIGEM"         => $row['PARCORIGINAL'],
                "DESTINO"        => $row['NRPARCNEGOCIO'],
                "NRORG"          => $row['NRORG'],
                "CDOPERADOR"     => $row['CDOPERINCLUSAO']
            );
            
            $stdFusao = $this->connection->prepare($sqlFusao);
            $stdFusao->execute($paramsFusao);
            
            $sqlParc= "UPDATE PARCNEGOCIO SET IDPARCFUNDIDO = 'S', IDATIVO = 'N', CDOPERULTATU = :CDOPERADOR, DTULTATU = SYSDATE WHERE NRPARCNEGOCIO = :PARCORIGINAL AND NRORG = :NRORG";
            
            $paramsFusao = array (
                "NRORG"          => $row['NRORG'],
                "PARCORIGINAL"   => $row['PARCORIGINAL'],
                "CDOPERADOR"     => $row['CDOPERINCLUSAO']
            );
            
            $stdParc = $this->connection->prepare($sqlParc);
            $stdParc->execute($paramsFusao);
            
            
            $sqlContato = "UPDATE CONTATO SET NRPARCNEGOCIO = :NRPARCNEGOCIO, CDOPERULTATU = :CDOPERADOR, DTULTATU = SYSDATE, NRORGULTATU = :NRORG WHERE NRORG = :NRORG AND NRPARCNEGOCIO = :PARCORIGINAL";
            
            $paramsContato = array (
                "NRORG"          => $row['NRORG'],
                "PARCORIGINAL"   => $row['PARCORIGINAL'],
                "NRPARCNEGOCIO"  => $row['NRPARCNEGOCIO'],
                "CDOPERADOR"     => $row['CDOPERINCLUSAO']
            );
            
            $stdParc = $this->connection->prepare($sqlContato);
            $stdParc->execute($paramsContato);
            
            $sqlOport = "UPDATE CRM_OPORTUNI SET NRPARCOPORT = :NRPARCNEGOCIO, CDOPERULTATU = :CDOPERADOR, DTULTATU = SYSDATE, NRORGULTATU = :NRORG WHERE NRORG = :NRORG AND NRPARCOPORT = :PARCORIGINAL";
            
            $paramsOport = array (
                "NRORG"          => $row['NRORG'],
                "PARCORIGINAL"   => $row['PARCORIGINAL'],
                "NRPARCNEGOCIO"  => $row['NRPARCNEGOCIO'],
                "CDOPERADOR"     => $row['CDOPERINCLUSAO']
            );
            
            $stdParc = $this->connection->prepare($sqlOport);
            $stdParc->execute($paramsOport);
            
            $sqlFila = "UPDATE FILACONTATO SET NRPARCNEGOCIO = :NRPARCNEGOCIO, CDOPERULTATU = :CDOPERADOR, DTULTATU = SYSDATE, NRORGULTATU = :NRORG WHERE NRORG = :NRORG AND NRPARCNEGOCIO = :PARCORIGINAL";
            
            $paramsFila = array (
                "NRORG"          => $row['NRORG'],
                "PARCORIGINAL"   => $row['PARCORIGINAL'],
                "NRPARCNEGOCIO"  => $row['NRPARCNEGOCIO'],
                "CDOPERADOR"     => $row['CDOPERINCLUSAO']
            );
            
            $stdParc = $this->connection->prepare($sqlFila);
            $stdParc->execute($paramsFila);
            
            $sqlPlanOcupa = "UPDATE PLANOCUPACAO SET NRPARCNEGOCIO = :NRPARCNEGOCIO, CDOPERULTATU = :CDOPERADOR, DTULTATU = SYSDATE, NRORGULTATU = :NRORG WHERE NRORG = :NRORG AND NRPARCNEGOCIO = :PARCORIGINAL";
            
            $paramsPlanOcupa = array (
                "NRORG"          => $row['NRORG'],
                "PARCORIGINAL"   => $row['PARCORIGINAL'],
                "NRPARCNEGOCIO"  => $row['NRPARCNEGOCIO'],
                "CDOPERADOR"     => $row['CDOPERINCLUSAO']
            );
            
            $stdParc = $this->connection->prepare($sqlPlanOcupa);
            $stdParc->execute($paramsPlanOcupa);

        } catch(\Exception $e) {
            throw $e;
        };
    }
    
    public function desativarStatusParc($row) {
        try {
            
            $sql= "DELETE FROM CRM_STATUSPARC WHERE NRPARCNEGOCIO = :NRPARCNEGOCIO AND NRORG = :NRORG AND CRM_NRORGTRAB = :CRM_NRORGTRAB";
            
            $params = array (
                "NRORG"          => $row['NRORG'],
                "NRPARCNEGOCIO"  => $row['PARCORIGINAL'],
                "CRM_NRORGTRAB"  => $row['CRM_NRORGTRAB']
            );
            
            $std = $this->connection->prepare($sql);
            $std->execute($params);

        } catch(\Exception $e) {
            throw $e;
        };
    }
    
}
?>