<?php

namespace Teknisa\CRM\Service;

class AgrupamentoParceiroService {
    
    protected $agrupamentoParceiroFactory;
    
    public function __construct($agrupamentoParceiroFactory) {
        
        $this->agrupamentoParceiroFactory = $agrupamentoParceiroFactory;
    }
    

    public function executeDeleteGroup($row){
        $paramsQuery = array (
            "NRAGRPARC"        => $row['NRAGRPARC'],
            "CRM_NRORGTRAB"    => $row['CRM_NRORGTRAB'],
            "NRORG"            => $row['NRORG']
        );
        
        $this->agrupamentoParceiroFactory->queryDeleteGroup($paramsQuery);
    }
    
    public function verifyGroup($row){
        $response = array();
        
        $paramsQuery = array (
            "NRPARCNEGOCIO_REL" => $row['NRPARCNEGOCIO'],
            "CRM_NRORGTRAB"     => $row['CRM_NRORGTRAB'],
            "NRORG"             => $row['NRORG']
        );
        
        $response = $this->agrupamentoParceiroFactory->verifyGroup($paramsQuery);
        
        if(!empty($response)) {
            return array($response, 'PPR');         //Parceiro-Pai Relacionado
        } else {
            $paramsQueryRel = array (
                "NRPARCNEGOCIO_REL"  => $row['NRPARCNEGOCIO_REL'],
                "CRM_NRORGTRAB"      => $row['CRM_NRORGTRAB'],
                "NRORG"              => $row['NRORG']
            );
            
            $response = $this->agrupamentoParceiroFactory->verifyGroup($paramsQueryRel);
            
            if(!empty($response)) {
                return array($response, 'PFR');     //Parceiro-Filgo Relacionado
            } else {
                return false;                          //Retorna falso se caso todas as verificações não acharem uma relação
            }
        }
        
    }

    public function verifyGroupRel($row){
        $response = array();
        
        $paramsQuery = array (
            "NRPARCNEGOCIO_REL" => $row['NRPARCNEGOCIO'],
            "CRM_NRORGTRAB"     => $row['CRM_NRORGTRAB'],
            "NRORG"             => $row['NRORG']
        );
        
        return $this->agrupamentoParceiroFactory->verifyGroup($paramsQuery);
    }
    
    public function agrupamentoEvolSave($row){
        $paramsQuery = array (
            "NRCONTATO"         => $row['NRCONTATO'],
            "DTHREVOLCONT"      => $row['DTHREVOLCONT'],
            "CDTIPOCONT"        => $row['CDTIPOCONT'],
            "IDSENEVOCONT"      => $row['IDSENEVOCONT'],
            "CDOPEREVOL"        => $row['CDOPEREVOL'],
            "CDMOTIEVOCON"      => $row['CDMOTIEVOCON'],
            "NRORG"             => $row['NRORG'],
            "CRM_NRORGTRAB"     => $row['CRM_NRORGTRAB'],
            "TXEVOLCONT"        => $row['TXEVOLCONT'],
            "NRSEQRESULEVOL"    => $row['NRSEQRESULEVOL'],
            "NRSEQEVOLCONT"     => $row['NRSEQEVOLCONT'],
            "NRSEQCONTATO"      => $row['NRSEQCONTATO'],
            "CDFILIAL"          => isset($row['CDFILIAL']) ? $row['CDFILIAL'] : null
        );
        
        $this->agrupamentoParceiroFactory->agrupamentoEvolSave($paramsQuery);
        
    }
    
    public function searchNrContato($row){
        $paramsQuery = array (
            "NRPARCNEGOCIO"     => $row['NRPARCNEGOCIO'],
            "NRORG"             => $row['NRORG']
        );
        
        return $this->agrupamentoParceiroFactory->searchNrContato($paramsQuery);
        
    }
    
}