var ZeedhiDirectives = angular.module("ZeedhiDirectives");

ZeedhiDirectives.directive('zhDeleteComponents', function(ApplicationContext, templateManager, restEngine, ScreenService) {
	var DELETE = "DELETE";
	var DELETEWIDGET = "DELETEWIDGET";
	return {
		link: function($scope, $element, $attributes, $controller) {
			function isDevWindow() {
				return ApplicationContext.WindowController.isDevToolsWindow();
			}

			function deleteComponent(DevToolsController) {
				var activeItemPath = DevToolsController.getActiveTreeItem().path;
				var type = activeItemPath[activeItemPath.length - 2];
				if (type && isDevWindow()) {
					var completeJson = Util.clone(window.currentContainer.__metadata);
					ShowInDevTools.clear(completeJson);
					var deleteType = DELETE;
					if(type == "widgets"){
						deleteType = DELETEWIDGET;
					}
					DevToolsController.deleteComponent(activeItemPath, completeJson, deleteType);
					setItemToOpen(activeItemPath, DevToolsController);
				} else if (!activeItemPath.length) {
					ScreenService.notificationMessage("Impossível deletar um container dessa maneira.", "information");
				}
			}
			$scope.deleteComponent = deleteComponent;

			function setItemToOpen(activeItemPath, DevToolsController) {
				if (activeItemPath[activeItemPath.length - 1] === 0) {
					activeItemPath.length = activeItemPath.length - 2;
				} else {
					var lastPosition = activeItemPath.length - 1;
					activeItemPath[lastPosition] = activeItemPath[lastPosition] - 1;
					if (activeItemPath[lastPosition] < 0) {
						activeItemPath[lastPosition] = 0;
					}
				}
				$scope.textIsReady = false;
				DevToolsController.openPath(activeItemPath);
			}
		}
	};
});