/* global UtilDevTools */
function DTCustomComponentCRUD(ElementToMetadataService){
    var NEW = 'NEW';

    var sendMessageToCustomizationService = function(functionName, args){
        var MainWindow = UtilDevTools.getMainWindow();
        MainWindow.executeFunction("DTCustomizationService", functionName, args);
    };

    var clearComponents = function(components){
        var zeedhiTypes = UtilDevTools.getZeedhiTypes().concat(UtilDevTools.getIgnoredZeedhiTypes());
        components.forEach(function deleteComponentExtraProperties(componentObject){
            zeedhiTypes.forEach(function deleteSubitems(type){
                delete componentObject[type];
            });
            delete componentObject.__indexPath;
            delete componentObject.fileName;
        });
    };

    var saveComponent = function(item, componentObject, pathToSave, inFileMode, option){
        var oldElement = ElementToMetadataService.getJsonElement(pathToSave || [], {__metadata: componentObject});
        var oldItem = oldElement.jsonElement;
        clearComponents([oldItem, item]);
        var changed = ElementToMetadataService.hasChanged(oldItem, item);
        if(changed){
            var args = [item, componentObject.id, pathToSave];
            sendMessageToCustomizationService("saveItemCustomization", args);
        }
    };

    this.saveComponentChange = function(newText, componentObject, pathToSave, inFileMode){
        var item = JSON.parse(newText);
        saveComponent(item, componentObject, pathToSave, inFileMode);
    };

    this.saveNewComponent = function(newText, pathToSave, componentObject, inFileMode){
        var item = JSON.parse(newText);
        item.id = item.id || "NEW" + new Date().getTime();
        saveComponent(item, componentObject, pathToSave, inFileMode, NEW);
    };

    this.deleteComponent = function(path, completeJson, deleteType){
        var item = path.reduce(function(current, key) {
                return current[key];
            }, completeJson);
        console.log("deleteComponent " + item);
    };

    this.deleteCustomFile = function(fileName){
        sendMessageToCustomizationService("deleteCustomFile", [fileName]);
    };

    this.resetContainer = function(){
        sendMessageToCustomizationService("resetContainer");
    };

    this.deleteComponentCustomization = function(itemId){
        sendMessageToCustomizationService("deleteItemCustomization", [itemId]);
    };

    this.newFile = function(data){
        console.log("newFile");
    };
}
